---
title: PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable()
slug: Web/API/PublicKeyCredential/isUserVerifyingPlatformAuthenticatorAvailable
tags:
  - API
  - Method
  - PublicKeyCredential
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p><strong><code>isUserVerifyingPlatformAuthenticatorAvailable()</code></strong> is a static method of the {{domxref("PublicKeyCredential")}} interface that returns a {{jsxref("Promise")}} which resolves to <code>true</code> if a user-verifying platform authenticator is available.</p>

<p>A user-verifying platform authenticator is a kind of multi-factor authenticator that is part of the client device (it is generally not removable) and that involves an action from the user in order to identify them.</p>

<p>At the time of this writing, this method's result only resolves to <code>true</code> on Windows when <a href="https://support.microsoft.com/help/17215/windows-10-what-is-hello">Windows Hello</a> capabilities are available (on recent versions of this OS).</p>

<div class="note">
<p><strong>Note:</strong> This method may only be used in top-level contexts and will not be available in an {{HTMLElement("iframe")}} for example.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable()</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which resolves to a {{jsxref("Boolean")}} indicating whether or a not a user-verifying platform authenticator is available. As of today (March 2019), this is basically indicating if <a href="https://support.microsoft.com/help/17215/windows-10-what-is-hello">Windows Hello</a> may be used with the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> and that the user has accepted its use.</p>

<div class="notecard note">
<p><strong>Note:</strong> This is a static method which is directly called on the {{domxref("PublicKeyCredential")}} interface and not on an instance.</p>
</div>

<div class="notecard note">
<p><strong>Note:</strong> In earlier versions of the specification, the boolean also conveyed the consent of the user to disclose such an authenticator existed.</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable()
  .then(function(available){
    if(available){
      // We can proceed with the creation of a PublicKeyCredential
      // with this authenticator
    } else {
      // Use another kind of authenticator or a classical login/password
      // workflow
    }
  }).catch(function(err){
    // Something went wrong
    console.error(err);
  });
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('WebAuthn','#dom-publickeycredential-isuserverifyingplatformauthenticatoravailable','isUserVerifyingPlatformAuthenticatorAvailable')}}</td>
			<td>{{Spec2('WebAuthn')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="https://docs.microsoft.com/en-us/windows-hardware/design/device-experiences/windows-hello">Windows Hello</a></li>
	<li><a href="https://docs.microsoft.com/en-us/microsoft-edge/dev-guide/windows-integration/web-authentication">Web Authentication and Windows Hello - MSDN Guide</a> and especially the <a href="https://docs.microsoft.com/en-us/microsoft-edge/dev-guide/windows-integration/web-authentication#special-considerations-for-windows-hello">special considerations mentioning <code>isUserVerifyingPlatformAuthenticator()</code></a></li>
</ul>
